#ifndef _BSPCPP_H // -*-C++-*-
#define _BSPCPP_H

// This is a C++ wrapper for Norman Chin's BSP code from Graphics Gems V.


#include <libtk/darray.h>
#include "base.h"


class BSP
{
    void *m_root;
    int   m_f2b;  // true if rendering front to back
    DArray<Polygon> m_output;


public:
    BSP( DArray<Polygon> &, int f2b=1 );
    virtual ~BSP();

    // the result of this should be deallocated
    DArray<Polygon> traverse( Vertex &viewPosition );

    // don't call this directly
    void renderCB( DArray<Polygon> & );
};


#endif // _BSPCPP_H
