#ifndef _FACTOR_H // -*-C++-*-
#define _FACTOR_H

#include <libtk/darray.h>
#include <libtk/map.h>
#include <libtk/camera.h>
#include "base.h"
#include "bspcpp.h"
#include "sphere.h"


double getUnoccludedFormFactor( Camera &, DArray<Polygon> & );


class FormFactor
{
    BSP *m_bsp;
    Sphere *m_sphere;
    Vertex m_point;
    Vertex m_normal;
    Map<int,DArray<Polygon> *> m_srcMap;

public:
    
    FormFactor( Camera &, DArray<Polygon> &src, DArray<Polygon> &occ,
		int storeSources = 1 );
    ~FormFactor();
    
    DArray<Polygon> &getRemainder( Polygon & );
    double           getFormFactor( Polygon & );

    friend ostream &operator<<( ostream &, FormFactor & );

};


#endif // _FACTOR_H
