#ifndef _HEMI_H
#define _HEMI_H

#include <libtk/camera.h>
#include "base.h"


class BWWindow;

class HemiCube
{
    BWWindow *m_up;
    BWWindow *m_north;
    BWWindow *m_east;
    BWWindow *m_south;
    BWWindow *m_west;

    Camera m_cam;
    int m_size;
    double m_near;
    double m_far;
    DArray<Polygon> &m_sources;
    DArray<Polygon> &m_occluders;
    int m_hide;

    void draw();
    void compute();

public:
    HemiCube( Camera &cam, DArray<Polygon> &src, DArray<Polygon> &occ, 
	      double near, double far, int hide=0 );

    void formFactor();

    friend class BWWindow;
};


#endif // _HEMI_H



