#ifndef _IO_H // -*-C++-*-
#define _IO_H

#include <fstream.h>
#include <libtk/darray.h>
#include "base.h"


template<class T> int
read( T &obj, const char *fileName )
{
    if( !fileName )
	return 0;
    
    ifstream in( fileName );
    int ret = 0;

    if( !in.bad() )
    {
	ret = 1;
	in >> obj;
    }
    return ret;
}
    

template<class T> int
write( T &obj, const char *fileName )
{
    if( !fileName )
	return 0;
    
    ofstream out( fileName );
    int ret = 0;

    if( !out.bad() )
    {
	ret = 1;
	out << obj;
    }
    return ret;
}


ostream &operator<<( ostream &, DArray<Polygon> & );
istream &operator>>( istream &, DArray<Polygon> & );

#endif // _IO_H
