#ifndef _SPHERE_H // -*-C++-*-
#define _SPHERE_H

#include <libtk/darray.h>
#include <libtk/camera.h>
#include "base.h"
#include "arc.h"
#include "tritree.h"


// #define USE_TRITREE

class Sphere
{
    VertexAVL m_vertTree;

#ifdef USE_TRITREE
    TriTree *m_tritree;
#else    
    DArray<Triangle> m_triangles;
#endif // USE_TRITREE    
    Vertex m_point;
    Vertex m_normal;
    DArray<Triangle> render( Polygon & );
    void insert( DArray<Triangle> & );
    
public:
    Sphere( Camera & );
    ~Sphere();

    void renderOccluder( Polygon & );
    DArray<Polygon> getVisibleSource( Polygon &, int store );
    DArray<Triangle> getTriangles();
};


#endif // _SPHERE_H
