#ifndef _TRITREE_H // -*-C++-*-
#define _TRITREE_H

#include <libtk/darray.h>
#include "base.h"
#include "arc.h"


class TriTree;

class TriTreeNode
{
    friend class TriTree;

    DArray<TriTreeNode> m_children;
    DArray<Triangle> m_triangles;
    DArray<Arc> m_arcs;

    TriTreeNode( ArcVertex &, ArcVertex &, ArcVertex &, VertexAVL &, int );
public:
    ~TriTreeNode();

    void add( Triangle & );
    void getTriangles( DArray<Triangle> &, Triangle & );
    void getAllTriangles( DArray<Triangle> & );
};


class TriTree
{
    DArray<TriTreeNode> m_children;
    DArray<Arc> m_arcs;
    VertexAVL m_verts;
    DArray<Triangle> m_triangles;

public:
    TriTree( Vertex, int );
    ~TriTree();

    void add( Triangle & );
    void add( DArray<Triangle> & );
    DArray<Triangle> getTriangles( Triangle & );
    DArray<Triangle> getAllTriangles();
};


#endif // _TRITREE_H







